#include "ODE.h"
#include "ODESolver.h"
#include <stdio.h>
#include <stdlib.h>

void main(int argc, char *argv[])
{
    FILE *fp;
    float y[2];
    int nvar = 2;
    float x1 = 0;
    float x2 = 100;
    float epsilon = 1e-6;
    float h1 = 1;
    float hmin=0;
    int nok;
    int nbad;
    float *xp;
    float **yp;
    float dxsave=0.5;
    int kount=0;
    int kmax=100;
    int i,j;

    
    if(argc==2)
    {
        if((xp = (float*)calloc(kmax,sizeof(float)))!=NULL && (yp = (float**) calloc(nvar,sizeof(float*)))!=NULL)
        {
        
            for(i=0;i<nvar;i++)
                (yp[i] = (float*) calloc(kmax,sizeof(float)));
        
        y[0]=1;
        y[1]=10;

        printf("initializing storage!\n");

        for(i=0;i<kmax;i++)
            xp[i] = 0.0;
        for(j=0;j<nvar;j++)
            for(i=0;i<kmax;i++)
                yp[j][i]=0.0;
        
        printf("memory initialized!\n");

        if((fp=fopen(argv[1],"w"))!=NULL)
        {
            fprintf(fp,"x, y[0], y[1]\n");

            ODESolve(y,nvar,x1,x2,epsilon,h1,hmin,&nok,&nbad,ODE_1,xp,yp,dxsave,&kount,kmax);
                
   
            for(i=0;i<kount;i++)
            {
                fprintf(fp,"%f, %f, %f\n",xp[i],yp[0][i],yp[1][i]);
            }
            printf("nok: %d nbad: %d Total: %d",nok,nbad,nok+nbad);
            fclose(fp);
        }
        else
        {
            printf("Cannot open file: %s for write\n",argv[1]);
        }
        free(xp);
        free(yp[0]);
        free(yp[1]);
        free(yp);
            
        }
            
    }
    else
        printf("Usage: ODETest filename\n");
}
