/*       Description: Ordinary Differential Equation   *
*                                                      *
*        Author: Shaylesh Mehta                        *
*                                                      *
*        Email: skmehta@connectmail.carleton.ca        *
*                                                      *
*        Date: January 10th 2002                       *
*                                                      */

#include "ODE.h"

#define R_1 100  //10K cutoff frequency
#define C_1 1E-6

//define all differential equations here and in ODE.h


//harmonic oscillator
void ODE_1(double x, double y[], double dydx[], double coupled_inputs[])
{
    dydx[0] = y[1];          //list FODE equations here
    dydx[1] = -0.2*y[1]-y[0];
}

// lowpass filter with vin exogenous, vout endogenous 
void ODE_2(double x, double y[], double dydx[], double coupled_inputs[])
{
    dydx[0] = (coupled_inputs[0] - y[0])/(R_1*C_1); //used R_1 and C_1 for simplicity, 
       //in actual design from elaborator, would be a literal
}
